import argparse
import urllib.request
from zeep import Client

LOGIN = "Administrator"
PWD = "wf"
DEFINITION_NAME = "complete_task_sample"

wfe_version = urllib.request.urlopen("http://localhost:8080/wfe/version").read().decode('utf-8')
if wfe_version:       
    BASE_URL = "http://localhost:8080/wfe-service-" + wfe_version
    AUTHENTICATION_API_URL = BASE_URL + "/AuthenticationWebService/AuthenticationAPI?wsdl"
    DEFINITION_API_URL = BASE_URL + "/DefinitionWebService/DefinitionAPI?wsdl"

    parser = argparse.ArgumentParser()
    parser.add_argument('-par')
    args = parser.parse_args()

    if args.par is not None:  
        print("Authentication:")
        authentication = Client(AUTHENTICATION_API_URL)
        user = authentication.service.authenticateByLoginPassword(LOGIN, PWD)
        print("    OK"); 
        definition_api = Client(DEFINITION_API_URL)
        with open(args.par, "rb") as par_file:            
            if args.par.endswith('.par'):
                definitionName = args.par[:-4]
                bytes = par_file.read()
                par_file.close()
                id = None
                try:                    
                    definitionResponse = definition_api.service.getLatestProcessDefinition(user, definitionName)                    
                    id = definitionResponse.id                                       
                except BaseException as err:
                    pass
                if id is None:
                    print("Deploy", definitionName, ":")                    
                    definition_api.service.deployProcessDefinition(user, bytes, ["GPD"])
                    print("    OK")                    
                else:                   
                    print("Redeploy definition", definitionName, ":")
                    definition_api.service.redeployProcessDefinition(user, id, bytes, ["GPD"])
                    print("    OK")                          
